Index: ui/tool/kis_tool.cc
===================================================================
--- ui/tool/kis_tool.cc	(revision 1177751)
+++ ui/tool/kis_tool.cc	(working copy)
@@ -71,11 +71,13 @@
 #include <recorder/kis_recorded_paint_action.h>
 
 struct KisTool::Private {
-    Private() : currentPattern(0),
-            currentGradient(0),
-            currentPaintOpPreset(0),
-            currentGenerator(0),
-            optionWidget(0) { }
+    Private()
+        : currentPattern(0),
+          currentGradient(0),
+          currentPaintOpPreset(0),
+          currentGenerator(0),
+          optionWidget(0),
+          spacePressed(0) { }
     QCursor cursor; // the cursor that should be shown on tool activation.
 
     // From the canvas resources
@@ -93,6 +95,10 @@
     KAction* toggleFgBg;
     KAction* resetFgBg;
 
+    bool spacePressed;
+    QPointF lastDocumentPoint;
+    QPointF initialGestureDocPoint;
+    QPoint initialGestureGlobalPoint;
 };
 
 KisTool::KisTool(KoCanvasBase * canvas, const QCursor & cursor)
@@ -114,6 +120,7 @@
     connect(d->resetFgBg, SIGNAL(triggered()), this, SLOT(slotResetFgBg()));
     addAction("reset_fg_bg", d->resetFgBg);
 
+    setMode(HOVER_MODE);
 }
 
 KisTool::~KisTool()
@@ -373,21 +380,183 @@
     return d->currentGenerator;
 }
 
+bool KisTool::specialModifierActive()
+{
+    KisCanvas2 *canvas2 = dynamic_cast<KisCanvas2 *>(canvas());
+    bool popupPalletActive = canvas2->handlePopupPaletteIsVisible();
+
+    KisConfig cfg;
+    return popupPalletActive || (d->spacePressed && !cfg.clicklessSpacePan());
+}
+
+void KisTool::setMode(ToolMode mode) {
+    m_mode = mode;
+}
+
+KisTool::ToolMode KisTool::mode() {
+    return m_mode;
+}
+
 void KisTool::mousePressEvent(KoPointerEvent *event)
 {
-    event->ignore();
+    KisConfig cfg;
+
+    if (mode() == KisTool::HOVER_MODE &&
+        ((event->button() == Qt::MidButton &&
+          event->modifiers() == Qt::NoModifier) ||
+         (d->spacePressed && !cfg.clicklessSpacePan()))) {
+
+        initPan(event->point);
+        event->accept();
+    }
+    else if (mode() == KisTool::HOVER_MODE &&
+             (event->button() == Qt::LeftButton &&
+              event->modifiers() == Qt::ShiftModifier)) {
+
+        initGesture(event->point);
+        event->accept();
+    }
+
+
+    d->lastDocumentPoint = event->point;
 }
 
 void KisTool::mouseMoveEvent(KoPointerEvent *event)
 {
-    event->ignore();
+    if(mode() == PAN_MODE) {
+        pan(event->point);
+        event->accept();
+    }
+    else if (mode() == GESTURE_MODE) {
+        processGesture(event->point);
+        event->accept();
+    }
+
+    d->lastDocumentPoint = event->point;
 }
 
 void KisTool::mouseReleaseEvent(KoPointerEvent *event)
 {
+    KisConfig cfg;
+
+    if(mode() == PAN_MODE) {
+        if (event->button() == Qt::MidButton ||
+            (event->button() == Qt::LeftButton && !cfg.clicklessSpacePan())) {
+
+            endPan();
+            event->accept();
+        }
+    }
+    else if (mode() == GESTURE_MODE) {
+        if (event->button() == Qt::LeftButton) {
+            endGesture();
+            event->accept();
+        }
+    }
+
+    d->lastDocumentPoint = event->point;
+}
+
+void KisTool::keyPressEvent(QKeyEvent *event)
+{
+    if (event->key() == Qt::Key_Space) {
+
+        KisConfig cfg;
+        if(cfg.clicklessSpacePan()) {
+            initPan(d->lastDocumentPoint);
+        }
+        else {
+            d->spacePressed = true;
+        }
+
+        event->accept();
+        return;
+    }
+
     event->ignore();
 }
 
+void KisTool::keyReleaseEvent(QKeyEvent* event)
+{
+    if (event->key() == Qt::Key_Space) {
+
+        KisConfig cfg;
+        if(cfg.clicklessSpacePan()) {
+            endPan();
+        }
+        else {
+            d->spacePressed = false;
+        }
+
+        event->accept();
+        return;
+    }
+
+    event->ignore();
+}
+
+void KisTool::initPan(const QPointF &docPoint)
+{
+    setMode(PAN_MODE);
+    m_lastPosition = convertDocumentToWidget(docPoint);
+    useCursor(QCursor(Qt::ClosedHandCursor));
+}
+
+void KisTool::pan(const QPointF &docPoint)
+{
+    Q_ASSERT(canvas());
+    Q_ASSERT(canvas()->canvasController());
+
+    QPointF actualPosition = convertDocumentToWidget(docPoint);
+    QPointF distance(m_lastPosition - actualPosition);
+    canvas()->canvasController()->pan(distance.toPoint());
+
+    m_lastPosition = actualPosition;
+}
+
+void KisTool::endPan()
+{
+    setMode(HOVER_MODE);
+    resetCursorStyle();
+}
+
+void KisTool::initGesture(const QPointF &docPoint)
+{
+    setMode(GESTURE_MODE);
+    d->initialGestureDocPoint = docPoint;
+    d->initialGestureGlobalPoint = QCursor::pos();
+    useCursor(KisCursor::blankCursor());
+}
+
+void KisTool::processGesture(const QPointF &docPoint)
+{
+    QPointF lastWidgetPosition = convertDocumentToWidget(d->lastDocumentPoint);
+    QPointF actualWidgetPosition = convertDocumentToWidget(docPoint);
+
+    QPointF offset = actualWidgetPosition - lastWidgetPosition;
+
+    /**
+     * view pixels != widget pixels, but we do this anyway, we only
+     * need to scale the gesture down, not rotate or anything
+     */
+    QPointF scaledOffset = canvas()->viewConverter()->viewToDocument(offset);
+    gesture(scaledOffset, d->initialGestureDocPoint);
+}
+
+void KisTool::endGesture()
+{
+    gesture(QPointF(), d->initialGestureDocPoint);
+    setMode(HOVER_MODE);
+    resetCursorStyle();
+    QCursor::setPos(d->initialGestureGlobalPoint);
+}
+
+void KisTool::gesture(const QPointF &offsetInDocPixels, const QPointF &initialDocPoint)
+{
+    Q_UNUSED(offsetInDocPixels);
+    Q_UNUSED(initialDocPoint);
+}
+
 void KisTool::setupPainter(KisPainter* painter)
 {
     Q_ASSERT(currentImage());
Index: ui/tool/kis_tool.h
===================================================================
--- ui/tool/kis_tool.h	(revision 1177751)
+++ ui/tool/kis_tool.h	(working copy)
@@ -28,6 +28,28 @@
 #include <krita_export.h>
 #include <kis_types.h>
 
+#define PRESS_CONDITION(_event, _mode, _button, _modifier)              \
+    (mode() == (_mode) && (_event)->button() == (_button) &&            \
+     (_event)->modifiers() == (_modifier) && !specialModifierActive())
+
+#define PRESS_CONDITION_WB(_event, _mode, _button, _modifier)            \
+    (mode() == (_mode) && (_event)->button() & (_button) &&            \
+     (_event)->modifiers() == (_modifier) && !specialModifierActive())
+
+#define PRESS_CONDITION_OM(_event, _mode, _button, _modifier)           \
+    (mode() == (_mode) && (_event)->button() == (_button) &&            \
+     ((_event)->modifiers() & (_modifier) ||                            \
+      (_event)->modifiers() == Qt::NoModifier) &&                       \
+     !specialModifierActive())
+
+#define RELEASE_CONDITION(_event, _mode, _button)               \
+    (mode() == (_mode) && (_event)->button() == (_button))
+
+#define RELEASE_CONDITION_WB(_event, _mode, _button)               \
+    (mode() == (_mode) && (_event)->button() & (_button))
+
+#define MOVE_CONDITION(_event, _mode) (mode() == (_mode))
+
 class KoCanvasBase;
 class KisPattern;
 class KoAbstractGradient;
@@ -74,17 +96,15 @@
 
     virtual void resourceChanged(int key, const QVariant & res);
 
-public:
+protected:
 
-    /// reimplemented from superclass
     virtual void mousePressEvent(KoPointerEvent *event);
-
-    /// reimplemented from superclass
     virtual void mouseMoveEvent(KoPointerEvent *event);
-
-    /// reimplemented from superclass
     virtual void mouseReleaseEvent(KoPointerEvent *event);
 
+    virtual void keyPressEvent(QKeyEvent *event);
+    virtual void keyReleaseEvent(QKeyEvent* event);
+
     /// reimplemented from superclass
     virtual void mouseDoubleClickEvent(KoPointerEvent *) {}  // when a krita tool is enabled, don't push double click on
 
@@ -135,6 +155,10 @@
 
 protected:
 
+    bool specialModifierActive();
+    virtual void gesture(const QPointF &offsetInDocPixels,
+                         const QPointF &initialDocPoint);
+
     KisImageWSP image() const;
     QCursor cursor() const;
 
@@ -176,6 +200,20 @@
     /// Sets the systemLocked for the current node, this will not deactivate the tool buttons
     void setCurrentNodeLocked(bool locked);
 
+protected:
+    enum ToolMode {
+        HOVER_MODE,
+        PAINT_MODE,
+        SECONDARY_PAINT_MODE,
+        GESTURE_MODE,
+        PAN_MODE,
+        OTHER // not used now
+    };
+
+    void setMode(ToolMode mode);
+    ToolMode mode();
+
+
 protected slots:
     /**
      * Called whenever the configuration settings change.
@@ -188,7 +226,18 @@
     void slotResetFgBg();
 
 private:
+    void initPan(const QPointF &docPoint);
+    void pan(const QPointF &docPoint);
+    void endPan();
+
+    void initGesture(const QPointF &docPoint);
+    void processGesture(const QPointF &docPoint);
+    void endGesture();
+
+private:
     PaintMode m_outlinePaintMode;
+    ToolMode m_mode;
+    QPointF m_lastPosition;
 
     struct Private;
     Private* const d;
Index: ui/tool/kis_tool_ellipse_base.cpp
===================================================================
--- ui/tool/kis_tool_ellipse_base.cpp	(revision 1177751)
+++ ui/tool/kis_tool_ellipse_base.cpp	(working copy)
@@ -29,8 +29,7 @@
 KisToolEllipseBase::KisToolEllipseBase(KoCanvasBase * canvas, const QCursor & cursor) :
         KisToolShape(canvas, cursor),
         m_dragStart(0,0),
-        m_dragEnd(0,0),
-        m_dragging(false)
+        m_dragEnd(0,0)
 {
 }
 
@@ -42,41 +41,38 @@
 {
     Q_UNUSED(converter);
     Q_ASSERT(currentImage());
-    if (m_dragging)
+    if (mode() == KisTool::PAINT_MODE)
         paintEllipse(gc, QRect());
 }
 
 void KisToolEllipseBase::deactivate()
 {
-    m_dragging=false;
     updateArea();
 }
 
 
 void KisToolEllipseBase::mousePressEvent(KoPointerEvent *event)
 {
-    Q_ASSERT(canvas() && currentImage());
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    if (!currentNode() || currentNode()->systemLocked()) {
-        return;
-    }
-    
-    if (event->button() == Qt::LeftButton) {
+        if (!currentNode() || currentNode()->systemLocked())
+            return;
+
+        setMode(KisTool::PAINT_MODE);
+
         QPointF pos = convertToPixelCoord(event);
-        m_dragging = true;
         m_dragStart = m_dragCenter = m_dragEnd = pos;
         event->accept();
     }
-    else if (event->button()==Qt::RightButton || event->button()==Qt::MidButton) {
-        m_dragging = false;
-        updateArea();
-        event->accept();
+    else {
+        KisTool::mousePressEvent(event);
     }
 }
 
 void KisToolEllipseBase::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         updateArea();
 
         QPointF pos = convertToPixelCoord(event);
@@ -109,21 +105,26 @@
         m_dragCenter = QPointF((m_dragStart.x() + m_dragEnd.x()) / 2,
                                (m_dragStart.y() + m_dragEnd.y()) / 2);
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
 void KisToolEllipseBase::mouseReleaseEvent(KoPointerEvent *event)
 {
-    Q_ASSERT(canvas() && currentImage());
-    if (!currentNode()) return;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (m_dragging && event->button() == Qt::LeftButton) {
         updateArea();
-        m_dragging = false;
+
         setCurrentNodeLocked(true);
         finishEllipse(QRectF(m_dragStart, m_dragEnd).normalized());
         setCurrentNodeLocked(false);
         event->accept();
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 
Index: ui/kis_config.cc
===================================================================
--- ui/kis_config.cc	(revision 1177751)
+++ ui/kis_config.cc	(working copy)
@@ -754,7 +754,6 @@
     m_cfg.writeEntry("presetChooserViewMode", mode);
 }
 
-
 bool KisConfig::firstRun() const
 {
     return m_cfg.readEntry("firstRun", true);
@@ -764,3 +763,13 @@
 {
     m_cfg.writeEntry("firstRun", first);
 }
+
+bool KisConfig::clicklessSpacePan() const
+{
+    return m_cfg.readEntry("clicklessSpacePan", true);
+}
+
+void KisConfig::setClicklessSpacePan(const bool toggle) const
+{
+    m_cfg.writeEntry("clicklessSpacePan", toggle);
+}
Index: ui/kis_config.h
===================================================================
--- ui/kis_config.h	(revision 1177751)
+++ ui/kis_config.h	(working copy)
@@ -269,8 +269,9 @@
     bool firstRun() const;
     void setFirstRun(const bool firstRun) const;
 
+    bool clicklessSpacePan() const;
+    void setClicklessSpacePan(const bool toggle) const;
 
-
 private:
     KisConfig(const KisConfig&);
     KisConfig& operator=(const KisConfig&);
